<?php

namespace FiloBlu\ExtAmastyGeoipRedirect\Block;

use FiloBlu\ExtAmastyGeoipRedirect\Helper\Data;
use Magento\Framework\View\Element\Template;
use Magento\Framework\View\Element\Template\Context;
use Magento\Store\Model\ScopeInterface;

/**
 * Class PopupMisfits
 * @package FiloBlu\ExtAmastyGeoipRedirect\Block
 */
class PopupMisfits extends Template
{
    public $_helper;
    protected $scopeConfig;

    /**
     * PopupMisfits constructor.
     * @param Context $context
     * @param Data $helper
     * @param array $data
     */
    public function __construct(
        Context $context,
        Data $helper,
        array $data = []
    ) {
        $this->jsLayout = $data['jsLayout'];
        $this->_helper = $helper;
        $this->scopeConfig = $context->getScopeConfig();

        parent::__construct($context, $data);
    }

    public function getConfig()
    {
        return [
            'misfits_cookie_name' => $this->_helper->getMisfitsCookieName(),
            'cookie_duration' => 2592000,
            'popup_id' => '#popup-geoip-misfits',
            'btn_continue_geoloc' => '#popup-geoip-misfits-continue-geoloc',
            'btn_close_advice' => '#popup-geoip-misfits-continue-close-advice',
            'btn_back' => '#popup-geoip-misfits-back',
            'language_list_container' => '#language-list-misfits .language-container',
            'language_link' => '.language-link-misfits',
            'store_urls' => $this->getAllStoreUrls()
        ];
    }

    public function getAllStoreUrls()
    {
        $output = [];
        $stores = $this->_storeManager->getStores(true);
        foreach ($stores as $store) {
            $output[$store->getId()] = $store->getBaseUrl();
        }
        return $output;
    }

    protected function _toHtml()
    {
        if (!$this->scopeConfig->getValue(
                'amgeoipredirect/general/enable',
                ScopeInterface::SCOPE_STORES
            ) || !$this->scopeConfig->getValue(
                'amgeoipredirect/misfits/enable_misfits',
                ScopeInterface::SCOPE_STORES
            )) {
            return '';
        }

        return parent::_toHtml();
    }

    protected function getCacheLifetime()
    {
        return 3600;
    }
}
